/* tcpspoof - v0.1 A tcp spoofer that uses libnet       */

#include <libnet.h>
#include <stdlib.h>

int 
main (int argc, char **argv)
{
  int l, c, network, packet_size;
  u_short src_port = 0;
  u_short dest_port = 0;
  int howmany = 1;
  u_char *packet;
  u_long src_ip = 0;
  u_long dst_ip = 0;
#if(WIN32) 
//defining due to a lack of definition in some header
#define IPTOS_LOWDELAY 0x10

  //init LibnetNT using libnet_win32_init(1);
  
  libnet_win32_init(1);

    //Added a different argument handling section for windows
  if (argc < 4)
    {
      fprintf (stderr, "\ntcpspoof - send a spoofed tcp packet\n");
      fprintf (stderr, "=-= dalec@eeye.com =-=\n");
      fprintf (stderr, "usage: %s [src ip] [src port] [dest ip] [dest port] [how many]\n\n", argv[0]);
      exit (EXIT_FAILURE);
    }
	  if (!(src_ip = libnet_name_resolve (argv[1], LIBNET_RESOLVE)))
	    {
	      libnet_error (LIBNET_ERR_FATAL, "Bad source IP: %s\n", argv[1]);
	    }
	    src_port = (u_short) atoi (argv[2]);
	    printf("Source port: %s\n", argv[2]);
	  if (!(dst_ip = libnet_name_resolve (argv[3], LIBNET_RESOLVE)))
	    {
	      libnet_error (LIBNET_ERR_FATAL, "No host: %s\n", argv[3]);
	    }
	  dest_port = (u_short) atoi (argv[4]);
	  printf("Dest port: %s\n", argv[4]);	
	  
	    howmany = atoi (argv[5]);

#else
  while ((c = getopt (argc, argv, "s:p:d:t:n:")) != EOF)
    {
      switch (c)
	{
	case 's':				/* Source IP address */
	  if (!(src_ip = libnet_name_resolve (optarg, LIBNET_RESOLVE)))
	    {
	      libnet_error (LIBNET_ERR_FATAL, "Bad source IP: %s\n", optarg);
	    }
	  break;
	case 'p':				/* Source port */
	  {
	    src_port = (u_short) atoi (optarg);
	    printf("Source port: %s\n", optarg);
	  }
	  break;
	case 'd':				/* Destination IP address */
	  if (!(dst_ip = libnet_name_resolve (optarg, LIBNET_RESOLVE)))
	    {
	      libnet_error (LIBNET_ERR_FATAL, "No host: %s\n", optarg);
	    }
	  break;
	case 't':
	  {
	    dest_port = (u_short) atoi (optarg);
	    printf("Dest port: %s\n", optarg);	
	  }   
	  break;
	case 'n':				/* Number of packets */
	  {
	    howmany = atoi (optarg);
	  }
	  break;
	}
  }
  if (argc < 4)
    {
      fprintf (stderr, "\ntcpspoof - send a spoofed tcp packet\n");
      fprintf (stderr, "=-= dalec@eeye.com =-=\n");
      fprintf (stderr, "usage: %s -s [src ip] -p [src port] -d [dest ip] -t [dest port] -n [how many]\n\n", argv[0]);
      exit (EXIT_FAILURE);
    }

#endif

  packet_size = LIBNET_IP_H + LIBNET_TCP_H;

  libnet_init_packet (packet_size, &packet);
  if (packet == NULL)
    {
      libnet_error (LIBNET_ERR_FATAL, "Failed.\n");
    }
  network = libnet_open_raw_sock (IPPROTO_RAW);
  if (network == -1)
    {
      libnet_error (LIBNET_ERR_FATAL, "Cannot open network.\n");
    }
  libnet_build_ip (LIBNET_TCP_H,			/* Length of the packet (excluding header */
		   IPTOS_LOWDELAY,			/* IP tos */
		   242,					/* IP Identification */
		   0,					/* Fragmentation flags */
		   48,					/* TTL */
		   IPPROTO_TCP,				/* Transport protocol */
		   src_ip,				/* Source IP address */
		   dst_ip,				/* Destination IP address */
		   NULL,				/* Pointer to packet data */
		   0,					/* Payload size */
		   packet);				/* pointer to packet header memory */

  libnet_build_tcp	 (src_port,			/* Source port */
			  dest_port,			/* Destination port */
			  0xa1d95,			/* Sequence number */
			  0x53,				/* Acknowledgement number */
			  TH_SYN,			/* Control flags */
			  1024,				/* Window size */
			  0,				/* Urgent pointer */
			  NULL,				/* Payload */ 
			  0,				/* Payload size */
			  packet + LIBNET_IP_H);	/* Pointer to packet header memory */

  
  if (libnet_do_checksum (packet, IPPROTO_TCP, LIBNET_TCP_H) == -1)
    {
      libnet_error (LIBNET_ERR_FATAL, "checksum failed\n");
    }
  for (l = 0; l < howmany; l++) /* Loop counter - how many packets to send */
    {
      c = libnet_write_ip (network, packet, packet_size);
    }
  if (c < packet_size)
    {
      libnet_error (LN_ERR_WARNING, "Only wrote %d bytes\n", c);
    }
  else
    {
      printf ("Completed.\n");
    }

  libnet_destroy_packet (&packet);			/* Free up memory */
  return (c == -1 ? EXIT_FAILURE : EXIT_SUCCESS);
}
